<ym-input-ft>
<div id="{divid}" name="{divname}" class='clearfix'>
	<div style='display: table-cell; float: left; height: 100%;'><img id="{fbid}" src='images/ymprev.png' onclick={backCLickHandler} style='vertical-align: middle;'></img></div>
	<div style='display: table-cell; float: left; height: 100%;'><input type="text" id="{fid}" name="{fname}" style="{style}" class="{css}" onchange={changeHandler} value="{valuef}" data-type="ym" placeholder="{placeholderFrom}" /></div>
	<div style='display: table-cell; float: left; height: 100%;'><img id="{fnid}" src='images/ymnext.png' onclick={nextClickHandler} style='vertical-align: middle;'></img></div>
	<div style='display: table-cell; float: left; height: 100%;'>&nbsp;～&nbsp;</div>
	<div style='display: table-cell; float: left; height: 100%;'><img id="{tbid}" src='images/ymprev.png' onclick={backCLickHandler} style='vertical-align: middle;'></img></div>
	<div style='display: table-cell; float: left; height: 100%;'><input type="text" id="{tid}" name="{tname}" style="{style}" class="{css}" onchange={changeHandler} value="{valuet}" data-type="ym" placeholder="{placeholderTo}" /></div>
	<div style='display: table-cell; float: left; height: 100%;'><img id="{tnid}" src='images/ymnext.png' onclick={nextClickHandler} style='vertical-align: middle;'></img></div>
</div>
<div><message tagid="{messageid}" msgstyle="{msgstyle}"></message></div>
<script>
	this.fid = opts.tagid + 'From';
	this.fname = (opts.name) ? opts.name + 'From' : opts.tagid + 'From';
	this.tid = opts.tagid + 'To';
	this.tname = (opts.name) ? opts.name + 'To' : opts.tagid + 'To';
	this.divid = opts.tagid + 'Div';
	this.divname = (opts.name) ? opts.name + 'Div' : opts.tagid + 'Div';
	this.messageid = opts.tagid + 'MessageDiv';
	this.css = 'bakyel ' + (opts.css ? opts.css : '');
	this.style = 'ime-mode: disabled; ' + (opts.style ? opts.style : 'width:65px');
	this.msgstyle = opts.msgstyle;
	this.placeholderFrom = (opts.placeholderFrom) ? opts.placeholderFrom : 'yyyy/mm';
	this.placeholderTo = (opts.placeholderTo) ? opts.placeholderTo : 'yyyy/mm';
	
	this.fbid = opts.tagid + 'FromBack';
	this.fnid = opts.tagid + 'FromNext';
	this.tbid = opts.tagid + 'ToBack';
	this.tnid = opts.tagid + 'ToNext';
	this.minyear = opts.minyear ? opts.minyear : '1900/01';
	this.maxyear = opts.maxyear ? opts.maxyear : '2999/12';
	
	this.valuef = opts.valuef;
	this.valuet = opts.valuet;
	
	this.regptn = /((\d{4})\/(\d{2}))/;

	backCLickHandler(ev) {
		ev.preventUpdate = true; // タグは自動では更新されない
		var id = ev.target.id;
		this.backcal(id.substring(0, id.length - 4));
	}
	nextClickHandler(ev) {
		ev.preventUpdate = true; // タグは自動では更新されない
		var id = ev.target.id;
		this.nextcal(id.substring(0, id.length - 4));
	}
	changeHandler(ev) {
		ev.preventUpdate = true; // タグは自動では更新されない
		var id = ev.target.id;
		chDatefmt(id);
	}
	
	backcal(id, isAdd) {
		if ($('#' + id).val().length < 1) {
			$('#' + id).val(valueToYm(Date.now()));
			return;
		}
		var rtn = this.checkcal(id, false);
		if (rtn) {
			this.calccal(id,-1);
		} else {
			console.log('err004:' + $(this.messageid));
		}
	}
	
	nextcal(id) {
		if ($('#' + id).val().length < 1) {
			$('#' + id).val(valueToYm(Date.now()));
			return;
		}
		var rtn = this.checkcal(id, true); 
		if (rtn) {
			this.calccal(id,1);
		} else {
			console.log('err004:' + $(this.messageid));
		}
	}
	
	calccal(id,num) {
		var dt = new Date();
		var dateYm = $('#' + id).val().split('/');
		dt.setDate(1);
		dt.setFullYear(dateYm[0]);
		dt.setMonth(Number(dateYm[1]) - 1 + num);
		$('#' + id).val(dt.getFullYear() + '/' + ('0' + (Number(dt.getMonth()+1))).slice(-2));
	}
	
	checkcal(id, isAdd) {
		chDatefmt(id);
		
		if($('#' + id).val().length < 1) {
			return false;
		}
		if(!$('#' + id).val().match(this.regptn)) {
			console.log('err002:' + $(this.messageid));
			return false;
		}
		
		var dtVal = ($('#' + id).val() + '/01').toDate();
		dtVal.setMonth(dtVal.getMonth() + (isAdd ? 1 : -1));
		var minVal = (this.minyear + '/01').toDate();
		var maxVal = (this.maxyear + '/01').toDate();
		if (!isAdd && dtVal.getTime() < minVal.getTime()) {
			return false;
		}
		if (isAdd && dtVal.getTime() > maxVal.getTime()) {
			return false;
		}
		
		return true;
	}

	function chDatefmt(id) {
		var inDate = $('#' + id).val();
		if (inDate.length > 4) {
			var year = parseInt(inDate.substr(0,4),10);
			
			if (year >= 1900 && year <= 2999 && (inDate.replace('/','')).length > 4) {
				var rtn = year + "/" + ('0' + (inDate.substr(4,inDate.length)).replace('/','')).slice(-2);
				$('#' + id).val(rtn);
			}
		}
	}

	/**
	 * マウント時の処理
	 */
	this.on('updated', function() {
		setDataObj(opts.tagid, opts);
	});
	
	/**
	 * キーがデータ属性に使用するキーかどうか
	 */
	function isDataAttrKey(key) {
		return key.startsWith('data-');
	}
	
	/**
	 * データ属性を設定する
	 */
	function setDataObj(id, val, forcingFlg) {
		Object.keys(val).forEach(function(key) {
			if (isDataAttrKey(camelToSnake(key, '-')) || forcingFlg) {
				var v = val[key];
				if (typeof v === 'object') {
					setDataObj(id, v, true);
				} else {
					$('#' + id + 'From').attr(forcingFlg ? 'data-' + key : camelToSnake(key, '-'), v);
					$('#' + id + 'To').attr(forcingFlg ? 'data-' + key : camelToSnake(key, '-'), v);
				}
			}
		});
	}
	
</script>
</ym-input-ft>
